package com.weaver.cronJob;

import java.time.LocalDate;
import weaver.conn.RecordSet;
import weaver.integration.logging.Logger;
import weaver.integration.logging.LoggerFactory;
import weaver.interfaces.schedule.BaseCronJob;

public class BudgetReceiptCountCronJob extends BaseCronJob {

   private static Logger logger = LoggerFactory.getLogger(BudgetReceiptCountCronJob.class);


   public void execute() {
      try {
         String e = this.BudgetOutturnCronJob_qsrq("BudgetOutturnCronJob_qsrq");
         LocalDate today = LocalDate.now();
         int year = today.getYear();
         int currentMonth = today.getMonthValue();
         int dayOfMonth = today.getDayOfMonth();
         String[] monthIdentifiers = new String[]{"apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dece", "jan", "feb", "mar"};
         StringBuilder sb = new StringBuilder();
         int startIndex;
         if(currentMonth == 4) {
            if(dayOfMonth <= Integer.parseInt(e.substring(8, 10))) {
               logger.info("当前月是4月，并且当前日期小于等于清算日期，则取去年的全部月份数据");
               startIndex = currentMonth + 8;
               --year;
            } else {
               logger.info("当前月是4月，并且当前日期大于清算日期，则取当月数据");
               startIndex = currentMonth - 3;
            }
         } else if(currentMonth >= 5) {
            logger.info("当前月是5月及之后, 起始索引为currentMonth - 4 就是 当前月 - 1个月");
            startIndex = currentMonth - 4;
         } else {
            logger.info("当前月是1-3月, 起始索引为currentMonth + 8 就是 当前月 - 1个月");
            startIndex = currentMonth + 8;
            --year;
         }

         for(int rs = 1; rs <= startIndex; ++rs) {
            if(sb.length() > 0) {
               sb.append(" + ");
            }

            sb.append(monthIdentifiers[rs - 1]);
         }

         RecordSet var12 = new RecordSet();
         String sql = "select id,(" + sb.toString() + ") as qnljyshj from uf_bmysb where gznf = \'" + year + "\'";
         var12.executeQuery(sql, new Object[0]);

         while(var12.next()) {
            var12.executeUpdate("update uf_bmysb set qnljyshj = " + var12.getString("qnljyshj") + " where id = " + var12.getString("id"), new Object[0]);
         }
      } catch (Exception var11) {
         logger.info("BudgetReceiptCountCronJob 部门预算表 更新统计数据发生异常：" + var11.getMessage(), var11);
      }

   }

   public static void main(String[] args) {
      LocalDate today = LocalDate.now();
      int year = today.getYear();
      byte currentMonth = 4;
      byte dayOfMonth = 6;
      String[] var10000 = new String[]{"apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dece", "jan", "feb", "mar"};
      new StringBuilder();
      int startIndex;
      if(currentMonth == 4) {
         if(dayOfMonth <= Integer.parseInt("2024-04-06".substring(8, 10))) {
            logger.info("当前月是4月，并且当前日期小于等于清算日期，则取去年的全部月份数据");
            startIndex = currentMonth + 8;
            --year;
         } else {
            logger.info("当前月是4月，并且当前日期大于清算日期，则取当月数据");
            startIndex = currentMonth - 3;
         }
      } else if(currentMonth >= 5) {
         logger.info("当前月是5月及之后, 起始索引为currentMonth - 4 就是 当前月 - 1个月");
         startIndex = currentMonth - 4;
      } else {
         logger.info("当前月是1-3月, 起始索引为currentMonth + 8 就是 当前月 - 1个月");
         startIndex = currentMonth + 8;
         --year;
      }

   }

   public String BudgetOutturnCronJob_qsrq(String sysKey) {
      RecordSet rs = new RecordSet();
      String sql = "select value from uf_systemConfig where key1 = \'" + sysKey + "\'";
      rs.executeQuery(sql, new Object[0]);
      rs.next();
      return rs.getString("value");
   }

}
